// |----------------------------|
// |  <3  Life-Steal Sword      |
// | By: @phosxd (discord - YT) |
// |----------------------------|



import * as MC from '@minecraft/server';


var LifestealBuffer = [];

// |===================|
// |   On Entity Hit   |
// |===================|
MC.world.afterEvents.entityHitEntity.subscribe(Event => {
    let Source = Event.damagingEntity;
    let Target = Event.hitEntity;
    let equippable = Source.getComponent('minecraft:equippable');
    if (equippable !== undefined) {
        let item = equippable.getEquipment('Mainhand');
        if (item === undefined) { }
        else {
            if (item.typeId === 'lfstsw:lifesteal_sword') {
                LifestealBuffer.push({ source: Source, target: Target });
            };
        };
    };
});

// |==================|
// |   On HP Change   |
// |==================|
MC.world.afterEvents.entityHealthChanged.subscribe(Event => {
    let Source = Event.entity;
    let Difference = Event.oldValue - Event.newValue;
    if (Difference > 0) {
        MC.system.run(() => {
            let count = -1;
            LifestealBuffer.forEach(item => {
                count += 1;
                if (Source.id !== item.target.id) { return; };
                let hpComp = item.source.getComponent('minecraft:health');
                hpComp.setCurrentValue(hpComp.currentValue + Difference);
                LifestealBuffer[count] = null;
            });
            LifestealBuffer = LifestealBuffer.filter(item_ => { return item_ !== null; });
        });
    };
});